using GTA;
using GTA.Native;
using System;
using System.Diagnostics;
using System.Drawing;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Runtime.Versioning;
using System.Windows.Forms;

namespace Laundromat
{
	public class cs : Script
	{
		private Keys toggleMenuKey;
		private Keys selectionKey;
		private Keys menuUpKey;
		private Keys menuDownKey;
		private bool isMenuOn;
		private bool menuReady;
		private int menuSelection;
		private float x;
		private float y;
		private float spacing;
		private Vector3[] positions;
		private bool Lessive()
		{
			Vector3[] array = this.positions;
			for (int i = 0; i < array.Length; i++)
			{
				Vector3 position = array[i];
				if (base.Player.Character.Position.DistanceTo(position) < 1f)
				{
					return true;
				}
			}
			return false;
		}
		public cs()
		{
			this.positions = new Vector3[]
			{
				// Add a new Vector3(Xf, Xf, Xf) line with the coordinates of your laundromat below to have your own laundromat . Don't forget the f and the lack of comma at last line
				// Ile est
				new Vector3(1017.69f, -324.36f, 20.22f),
				// Ile centrale
				// Ile ouest
				new Vector3(-1040.91f, 1130.27f, 13.73f)

			};
			// Remove the // below (i said below) to see the laundromat locations on map
			//Vector3[] array = this.positions;				
			//for (int i = 0; i < array.Length; i++)
			//{
				//Vector3 target = array[i];
				//Blip blip = Blip.AddBlip(target);
				//blip.Name = "YOU WILL NEVER SEE THIS";
				//blip.ShowOnlyWhenNear = true;
				//blip.Icon = BlipIcon.Building_ClothShop;
				//blip.Scale = 1f;
				//blip.Display = BlipDisplay.ArrowAndMap;
			//}
			this.x = (float)Game.Resolution.Width * 0.1f;
			this.y = (float)Game.Resolution.Height * 0.1f;
			this.spacing = (float)Game.Resolution.Height / 50f;
			// below is menu key . change it to your liking (example Keys.M if you want to use M key)
			this.toggleMenuKey = base.Settings.GetValueKey("TOGGLE_MENU_KEY", Keys.U);
			this.selectionKey = base.Settings.GetValueKey("SELECTION_KEY", Keys.Return);
			this.menuUpKey = base.Settings.GetValueKey("MENU_UP_KEY", Keys.Prior);
			this.menuDownKey = base.Settings.GetValueKey("MENU_DOWN_KEY", Keys.Next);
			base.BindKey(this.toggleMenuKey, false, false, false, new KeyPressDelegate(this.ToggleMenu));
			base.Tick += new EventHandler(this.HelpTick);
		}
		private void ToggleMenu()
		{
			if (!this.menuReady)
			{
				return;
			}
			this.isMenuOn = !this.isMenuOn;
			if (this.isMenuOn)
			{
				base.Tick -= new EventHandler(this.HelpTick);
				base.PerFrameDrawing += new GraphicsEventHandler(this.Menu_PerFrameDrawing);
				base.KeyDown += new GTA.KeyEventHandler(this.Menu_KeyDown);
				base.Player.CanControlCharacter = false;
				return;
			}
			base.Tick += new EventHandler(this.HelpTick);
			base.PerFrameDrawing -= new GraphicsEventHandler(this.Menu_PerFrameDrawing);
			base.KeyDown -= new GTA.KeyEventHandler(this.Menu_KeyDown);
			base.Player.CanControlCharacter = true;
		}
		private void Menu_KeyDown(object sender, GTA.KeyEventArgs e)
		{
			if (e.Key == this.menuUpKey)
			{
				this.menuSelection--;
				this.menuSelection = ((this.menuSelection < 0) ? 1 : this.menuSelection);
			}
			if (e.Key == this.menuDownKey)
			{
				this.menuSelection++;
				this.menuSelection = ((this.menuSelection > 1) ? 0 : this.menuSelection);
			}
			if (e.Key == this.selectionKey)
			{
				switch (this.menuSelection)
				{
				case 0:
					this.Laver();
					break;
				default:
					return;
				}
			}
		}
		private void Menu_PerFrameDrawing(object sender, GraphicsEventArgs e)
		{
			e.Graphics.DrawText("Washing (3$)", this.x, this.y, (this.menuSelection == 0) ? Color.PaleTurquoise : Color.Yellow);
		}

				private void Laver()
		{
			if (base.Player.Money >= 3)
			{
				Game.FadeScreenOut(2000, true);
				Function.Call("SET_TIME_OF_DAY", new Parameter[]
				{
					World.CurrentDayTime.Hours ,
					World.CurrentDayTime.Minutes + 30
				});
				Function.Call("RESET_VISIBLE_PED_DAMAGE", Player.Character);
				Wait(0);
				this.ToggleMenu();
				Game.FadeScreenIn(2000, true);
				base.Player.Money -= 3;
				Function.Call("PRINT_STRING_WITH_LITERAL_STRING_NOW", new Parameter[]
				{
					"STRING",
					"Your clothes have been cleaned!",
					2000,
					1
				});
				return;
			}
			Game.DisplayText("Pas assez d'argent.");
		}

		private void HelpTick(object sender, EventArgs e)
		{
			this.menuReady = this.Lessive();
			if (this.menuReady)
			{
				Game.DisplayText("Press U to do the washing", 250);
			}
		}
	}
}
